/* per filter structure
*/

#ifndef IP_FILTER
#define IP_FILTER

#ifndef TRUE
#define TRUE	1
#endif
#ifndef FALSE
#define FALSE	0
#endif

#ifndef IPCOUNTER
#define IPCOUNTER	1
typedef unsigned long COUNTER;
#endif

/* each filter data definition element has
 * #include, counter structure, configured variable
 */

#define FIXED_IPPROTO 1
struct fixed_ipproto {
	int	 configured;
	COUNTER  tcp_bytes;
	COUNTER  udp_bytes;
	COUNTER  icmp_bytes;
	COUNTER  xtra_bytes;
};
extern struct fixed_ipproto fixed_ipproto;

#define FIXED_TCP3   2
struct fixed_tcp3 {
	int configured;
	unsigned short tcp_port1;
	unsigned short tcp_port2;
	COUNTER  port1_bytes;
	COUNTER  port2_bytes;
	COUNTER  xtra_bytes;
};
extern struct fixed_tcp3 fixed_tcp3;

#define FIXED_IPRANGE1	3
struct fixed_iprange1 {
	int configured;
	struct in_addr ipaddr1;
	struct in_addr ipnet1;
	char s_ipnet1[1024];
	struct in_addr netmask1;
	struct in_addr ipaddr2;
	struct in_addr ipnet2;
	char s_ipnet2[1024];
	struct in_addr netmask2;
	COUNTER	 range1_bytes;
	COUNTER  extra_bytes;
};
extern struct fixed_iprange1 fixed_iprange1;

#define SPEC_IPPROTO  4
struct spec_ipproto {
	int	 configured;
	unsigned short proto1;
	unsigned short proto2;
	unsigned short proto3;
	COUNTER  proto1_bytes;
	COUNTER  proto2_bytes;
	COUNTER  proto3_bytes;
	COUNTER  xtra_bytes;
};
extern struct spec_ipproto spec_ipproto;

#define FIXED_CAST  5
struct fixed_cast {
	int	 configured;
	struct in_addr ipaddr1;  /* input, anded with netmask */
	struct in_addr netmask1;
	struct in_addr ipnet1;   /* computed all 1's bcast */
	struct in_addr ipnet0;   /* computed all 0's bcast */
	COUNTER  mcast_bytes;
	COUNTER  ucast_bytes;
	COUNTER  bcast_bytes;
	COUNTER  xtra_bytes;
};
extern struct fixed_cast fixed_cast;

#define FIXED_SIZE  6
struct fixed_size {
	int	 configured;
	COUNTER  tiny;
	COUNTER  small;
	COUNTER  medium;
	COUNTER  large;
};
extern struct fixed_size fixed_size;

/************************************************** 
 * TOPN
 **************************************************/

#define MAXTOPN		9	/* hard topN maximum. can't have more */

#include "hashsort.h"

#define TOPN_IP	    20
struct topn_ip {
	int configured;
	int actualn;		/* specified value of topN < MAXTOPN */
	struct list iplist;	/* ip dst top N link structure */
};
extern struct topn_ip topn_ip;

#endif
